# Inspired by livna 
# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.19-1.2895.fc6}

%define kmod_name alsa-driver
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen
%define kdumpvar kdump
%endif
%ifarch i686 x86_64 ppc
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Summary:   Alsa driver for linux
Name:      alsa-driver-kmod
Version:   1.0.14
Release:   0.1.rc2.%(echo %{kverrel} | tr - _)
License:   GPL
Group:     System Environment/Kernel 
Source:    ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%{version}rc2.tar.bz2
URL:       http://www.alsa-project.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:  alsa-driver-kmod-common = %{version}-%{release}
Provides:  alsa-driver-kmod = %{version}-%{release}

%description
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features:
- Efficient support for all types of audio interfaces, from consumer
 soundcards to professional multichannel audio interfaces.
- Fully modularized sound drivers.
- SMP and thread-safe design.
- User space library (alsa-lib) to simplify application programming and
 provide higher level functionality.
- Support for the older OSS API, providing binary compatibility for most
 OSS programs.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -n %{name}-%{version}rc2

## Fix the #include <linux/config.h> - call deprecated since 2.6.18
# from Ville Skytta - madwifi package.
#grep -rlF '<linux/config.h>' %{kmod_name}-%{version}rc2 \
#| xargs sed -i -e 's|<linux/config.h>|<linux/autoconf.h>|'

for kvariant in %{kvariants} ; do
  cp -a %{kmod_name}-%{version}rc2 _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
cd _kmod_build_$kvariant
%configure \
  --with-redhat=yes \
  --with-moddir=/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name} \
  --with-kernel="${ksrc}" \
  --with-build="${ksrc}"
make 
#  KERNEL_PATH="${ksrc}" \
#  KERNELRELEASE=%{kverrel}${kvariant} \
#compile
cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
pushd _kmod_build_$kvariant
#install -D -m 0644 *.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}/
make \
  DESTDIR=$RPM_BUILD_ROOT \
  install-modules 
popd
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT



%changelog
* Wed Jan 17 2007 kwizart < kwizart at gmail .com > - 1.0.14-0.1.rc2
- Initial release
